; 65c816 opcodes 0x80-0x8F:
;    80: BRA r       2,2
;    81: STA (d,x)   2,6
;    82: BRL rl      3,3
;    83: STA d,s     2,4
;    84: STY d       2,3
;    85: STA d       2,3
;    86: STX d       2,3
;    87: STA [d]     2,6
;    88: DEY i       1,2
;    89: BIT #       2,2
;    8A: TXA i       1,2
;    8B: PHB s       1,3
;    8C: STY a       3,4
;    8D: STA a       3,4
;    8E: STX a       3,4
;    8F: STA al      4,5

; 80

ALIGNC
ALL_BRA:
 movsx eax,byte [1+R_NativePC]
 add R_NativePC,byte 2
 add R_NativePC,eax
 jmp near CPU_RETURN

; 81
EM_STA Od_xO,Direct_Indexed_Indirect
E0_STA Od_xO,Direct_Indexed_Indirect

; 82

ALIGNC
ALL_BRL:                ; Branch always long (-32768 to 32767)
 mov al,[1+R_NativePC]
 GET_PC ebx
 mov ah,[2+R_NativePC]
 add ebx,byte 3
 add eax,ebx
 xor ebx,ebx
 movzx R_NativePC,ax
 mov bl,B_PB
 add ah,ah
 adc ebx,ebx
 mov eax,[_Read_BankOffset+ebx*4]
 add R_NativePC,eax
 mov B_PBOffset,eax
 jmp near CPU_RETURN

; 83
EM_STA d_s,Stack_Relative
E0_STA d_s,Stack_Relative

; 84
EX_STY d,Direct
E0_STY d,Direct

; 85
EM_STA d,Direct
E0_STA d,Direct

; 86
EX_STX d,Direct
E0_STX d,Direct

; 87
EM_STA IdI,Direct_Indirect_Long
E0_STA IdI,Direct_Indirect_Long

; 88

ALIGNC
EX_DEY:
 inc R_NativePC
 dec byte B_Y
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E0_DEY:
 inc R_NativePC
 dec word B_Y
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; 89    ; Differs from norm, only sets Z flag

ALIGNC
EM_BIT_i:
 mov al,[1+R_NativePC]
 add R_NativePC,byte 2
 test al,B_A
 STORE_FLAGS SNES_FLAG_Z
 jmp near CPU_RETURN
ALIGNC
E0_BIT_i:
 mov al,[1+R_NativePC]
 mov ah,[2+R_NativePC]
 add R_NativePC,byte 3
 test ax,B_A
 STORE_FLAGS SNES_FLAG_Z
 jmp near CPU_RETURN

; 8A

ALIGNC
EM_TXA:
 inc R_NativePC
 mov al,B_X
 mov B_A,al
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E0_TXA:
 inc R_NativePC
 mov eax,B_X
 mov B_A,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; 8B

ALIGNC
E0_PHB:
 inc R_NativePC
 mov al,B_DB
 E0_PUSH_B
 jmp near CPU_RETURN

ALIGNC
E1_PHB:
 inc R_NativePC
 mov al,B_DB
 E1_PUSH_B
 jmp near CPU_RETURN

; 8C
EX_STY a,Absolute
E0_STY a,Absolute

; 8D
EM_STA a,Absolute
E0_STA a,Absolute

; 8E
EX_STX a,Absolute
E0_STX a,Absolute

; 8F
EM_STA al,Absolute_Long
E0_STA al,Absolute_Long
