; 65c816 opcodes 0xF0-0xFF:
;    F0: BEQ r       2,2
;    F1: SBC (d),y   2,5
;    F2: SBC (d)     2,5
;    F3: SBC (d,s),y 2,7
;    F4: PEA s       3,5
;    F5: SBC d,x     2,4
;    F6: INC d,x     2,6
;    F7: SBC [d],y   2,6
;    F8: SED i       1,2
;    F9: SBC a,y     3,4
;    FA: PLX s       1,4
;    FB: XCE i       1,2
;    FC: JSR (a,x)   3,6
;    FD: SBC a,x     3,4
;    FE: INC a,x     3,7
;    FF: SBC al,x    4,5

; F0
BFS BEQ,SNES_FLAG_Z

; F1
EM_SBC OdO_y,Direct_Indirect_Indexed
E0_SBC OdO_y,Direct_Indirect_Indexed

; F2
EM_SBC OdO,Direct_Indirect
E0_SBC OdO,Direct_Indirect

; F3
EM_SBC Od_sO_y,Stack_Relative_Indirect_Indexed
E0_SBC Od_sO_y,Stack_Relative_Indirect_Indexed

; F4

ALIGNC
E0_PEA:
 mov al,[1+R_NativePC]
 mov ah,[2+R_NativePC]
 add R_NativePC,byte 3
 E0_PUSH_W
 jmp near CPU_RETURN

ALIGNC
E1_PEA:
 mov al,[1+R_NativePC]
 mov ah,[2+R_NativePC]
 add R_NativePC,byte 3
 E1_PUSH_W
 jmp near CPU_RETURN

; F5
EM_SBC d_x,Direct_Index_X
E0_SBC d_x,Direct_Index_X

; F6
EM_INC d_x,Direct_Index_X
E0_INC d_x,Direct_Index_X

; F7
EM_SBC IdI_y,Direct_Indirect_Indexed_Long
E0_SBC IdI_y,Direct_Indirect_Indexed_Long

; F8

ALIGNC
ALL_SED:
 inc R_NativePC
 SET_FLAG SNES_FLAG_D
 jmp near CPU_RETURN

; F9
EM_SBC a_y,Absolute_Index_Y
E0_SBC a_y,Absolute_Index_Y

; FA

ALIGNC
E0_PLX:
 inc R_NativePC
 E0_PULL_W
 mov B_X,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
EX_PLX:
 inc R_NativePC
 E0_PULL_B
 mov B_X,al
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E1_PLX:
 inc R_NativePC
 E1_PULL_B
 mov B_X,al
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; FB

ALIGNC
E0_XCE:
 inc R_NativePC

 JUMP_NOT_FLAG SNES_FLAG_C,CPU_RETURN,near
 mov B_XH,ah
 mov B_YH,ah
 CLR_FLAG SNES_FLAG_C
 SET_FLAG (SNES_FLAG_E+SNES_FLAG_B1)
 mov B_SH,0x01
 mov dword [OpTable],OpTableE1  ; Set current opcode emulation table
 jmp near CPU_RETURN

ALIGNC
E1_XCE:
 inc R_NativePC

 JUMP_FLAG SNES_FLAG_C,CPU_RETURN,near
 SET_FLAG (SNES_FLAG_C+SNES_FLAG_MX)
 CLR_FLAG SNES_FLAG_E
 mov dword [OpTable],OpTableMX  ; Set current opcode emulation table
 jmp near CPU_RETURN

; FC

ALIGNC
E0_JSR_Oa_xO:
 GET_PC eax
 add eax,byte 2     ; last instruction byte PC in ax
 E0_PUSH_W          ; Address of last byte not next instruction (huh!)
 ADDR_Absolute_Indexed_Indirect
 xor ebx,ebx
 mov R_NativePC,eax
 add ah,ah
 mov bl,B_PB
 adc ebx,ebx
 mov eax,[_Read_BankOffset+ebx*4]
 add R_NativePC,eax
 mov B_PBOffset,eax
 jmp near CPU_RETURN

ALIGNC
E1_JSR_Oa_xO:
 GET_PC eax
 add eax,byte 2     ; last instruction byte PC in ax
 E1_PUSH_W          ; Address of last byte not next instruction (huh!)
 ADDR_Absolute_Indexed_Indirect
 xor ebx,ebx
 mov R_NativePC,eax
 add ah,ah
 mov bl,B_PB
 adc ebx,ebx
 mov eax,[_Read_BankOffset+ebx*4]
 add R_NativePC,eax
 mov B_PBOffset,eax
 jmp near CPU_RETURN

; FD
EM_SBC a_x,Absolute_Index_X
E0_SBC a_x,Absolute_Index_X

; FE
EM_INC a_x,Absolute_Index_X
E0_INC a_x,Absolute_Index_X

; FF
EM_SBC al_x,Absolute_Long_Index_X
E0_SBC al_x,Absolute_Long_Index_X
