%ifndef SNEeSe_CPUmem_i
%define SNEeSe_CPUmem_i

%if 0

Macro's included in this ASM header

All macros assume ebx contains 24-bit address, al or ax (depending on size)
the location to return data (for read) or accept data (for write) at.
edi is always corrupted.

GET_BYTE    Get byte from any bank
GET_BYTE_00 Get byte from bank 00
GET_BYTE_PB Get byte from program bank
GET_WORD    Get word from any bank
GET_WORD_00 Get word from bank 00
GET_WORD_PB Get word from program bank
SET_BYTE    Set byte in any bank
SET_BYTE_00 Set byte in bank 00
SET_WORD    Set word in any bank
SET_WORD_00 Set word in bank 00

GET_WORD, GET_WORD_00, and GET_WORD_PB may be passed an optional
'Reverse=1' parameter to skip the last xchg. If this is done, the low
byte will be returned in ah, high byte in al.

SET_WORD and SET_WORD_00 may be passed an optional 'NoSave=1' parameter
to prevent the push/pop used to preserve the data word.

SET_WORD_Double and SET_WORD_00_Double use al for both high and low bytes of
write data. eax is not modified.

SET_WORD_HL and SET_WORD_HL_00 are alternate macros for when the address
being passed in is of the high byte, and the high byte will be written first.
These alternate macros do not support NoSave or Double.
%endif

%macro GET_BYTE 0
; mov edi,ebx
; shr edi,16     ; Get bank for indexing
; call [_Read_BankMapping+edi*4]
 mov edi,ebx
 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz %%read_direct
 mov edi,ebx
 shr edi,13
 call [_Read_Bank8Mapping+edi*4]
 jmp %%read_done
%%read_direct:
 mov al,[edi+ebx]
%%read_done:
%endmacro

%macro GET_BYTE_00 0
 call [_Read_BankMapping]
%endmacro

%macro GET_BYTE_PB 0
 call [_PB_Read]
%endmacro

;%1 = Reverse
%macro GET_WORD 0-1 0
 GET_BYTE
 mov ah,al
 inc ebx
 GET_BYTE
%ifnidni %1,Reverse
 xchg ah,al
%endif
%endmacro

;%1 = Reverse
%macro GET_WORD_00 0-1 0
 GET_BYTE_00
 mov ah,al
 inc ebx
 GET_BYTE
%ifnidni %1,Reverse
 xchg ah,al
%endif
%endmacro

;%1 = Reverse
%macro GET_WORD_PB 0-1 0
 GET_BYTE_PB
 movb ah,al
 inc ebx
 GET_BYTE_PB
%ifnidni %1,Reverse
 xchg ah,al
%endif
%endmacro

%macro SET_BYTE_00 0
 call [_Write_BankMapping]
%endmacro

%macro SET_BYTE 0
; mov edi,ebx
; shr edi,16
; call [_Write_BankMapping+edi*4]
 mov edi,ebx
 shr edi,13
 mov edi,[_Write_Bank8Offset+edi*4]
 test edi,edi
 jnz %%write_direct
 mov edi,ebx
 shr edi,13
 call [_Write_Bank8Mapping+edi*4]
 jmp %%write_done
%%write_direct:
 mov [edi+ebx],al
%%write_done:
%endmacro

;%1 = NoSave/Double
%macro SET_WORD_00 0-1 0
 SET_BYTE_00
%ifnidni %1,Double
%ifnidni %1,NoSave
 push eax
%endif
 mov al,ah
%endif
 inc ebx
 SET_BYTE
%ifnidni %1,Double
%ifnidni %1,NoSave
 pop eax
%endif
%endif
%endmacro

;%1 = NoSave/Double
%macro SET_WORD 0-1 0
 SET_BYTE
%ifnidni %1,Double
%ifnidni %1,NoSave
 push eax
%endif
 mov al,ah
%endif
 inc ebx
 SET_BYTE
%ifnidni %1,Double
%ifnidni %1,NoSave
 pop eax
%endif
%endif
%endmacro

%macro SET_WORD_HL 0
 push eax
 mov al,ah
 SET_BYTE
 pop eax
 dec ebx
 SET_BYTE
%endmacro

%macro SET_WORD_00_HL 0
 push eax
 mov al,ah
 SET_BYTE_00
 pop eax
 dec ebx
 SET_BYTE
%endmacro

%endif ; !SNEeSe_CPUmem_i
