%ifndef SNEeSe_screen_ni
%define SNEeSe_screen_ni

%macro WIPE_SNES_SCREEN 0
 mov edi,[_BKG]
 xor eax,eax
 mov ecx,((256+64)*240+64)/4
 rep stosd
%endmacro

%macro SyncRender 0
 mov edi,[Ready_Line_Render]
 sub edi,[Current_Line_Render]
 jbe  %%no_sync_needed
 call Sync_Render
%%no_sync_needed:
%endmacro

%macro RenderScanline 0
 inc dword [Ready_Line_Render]
%if 0
 mov eax,[Ready_Line_Render]
 inc eax
 mov ebx,[BG1VOFS]
 mov [Ready_Line_Render],eax
 mov esi,[BG1HOFS]
 mov [eax*4+LineBG1OFS+0],bx
 mov edi,[BG2VOFS]
 mov [eax*4+LineBG1OFS+4],si
 mov ebx,[BG2HOFS]
 mov [eax*4+LineBG2OFS+0],di
 mov esi,[BG3VOFS]
 mov [eax*4+LineBG2OFS+4],bx
 mov edi,[BG3HOFS]
 mov [eax*4+LineBG3OFS+0],si
 mov ebx,[BG4VOFS]
 mov [eax*4+LineBG3OFS+4],di
 mov esi,[BG4HOFS]
 mov [eax*4+LineBG4OFS+0],bx
 mov [eax*4+LineBG4OFS+4],si
%endif
%if 0
 mov edi,[ScreenDestPtr]
 xor eax,eax
 mov ebp,byte 256/32

ALIGNC
%%clear_loop:
 lea esi,[16+edi]
 mov [edi],eax
 mov [4+edi],eax
 mov [8+edi],eax
 mov [12+edi],eax
 mov %eax,[esi]
 lea edi,[16+esi]
 mov [4+esi],eax
 mov [8+esi],eax
 mov [12+esi],eax
 dec ebp
 jnz %%clear_loop

 mov ah,[_INIDISP]
 test ah,ah     ; Check for screen off
 js %%screen_off

 mov bl,[SCR_TM]    ; Get BG status for main screens
 call [Render_Mode]
 mov bl,[SCR_TS]    ; Get BG status for sub screens
 call [Render_Mode]
 mov edi,[ScreenDestPtr]
 add edi,256        ; Point screen to next line
%%screen_off:
 add edi,byte 64    ; Point screen to next line
 mov [ScreenDestPtr],edi
%endif
%endmacro

%macro Get_Current_Line 0
; parameters: none
; uses: eax, ebx, 0-label
; returns: eax

 ; Handle vertical mosaic
 mov eax,[Current_Line_Mosaic]
 mov bl,[Mosaic+edx]
 test bl,bl
 jnz %%mosaic_enabled
 mov eax,[Current_Line_Render]
%%mosaic_enabled:
 ; End vertical mosaic
%endmacro

; v0.25 - One macro for 8x8 and 16x8 tiles
;%1 = offset_change
%macro SORT_TILES_8_TALL 1 0
; parameters: edx
; uses: eax, esi, 0-label
; returns: ebx, LineAddress, LineAddressY

 Get_Current_Line

%ifidni %1,offset_change
 mov [Current_Line_Offset],eax
%endif

 add eax,[VScroll+edx]
 shl eax,3      ; Get screen offset
 mov ebx,0xF8*8 ; Current line + V scroll * 32words
 and ebx,eax
 mov esi,8*7
%ifidni %1,offset_change
 mov [MapAddress_Base],ebx
%endif
 and eax,0x07*8 ; Line offset in tile
 sub esi,eax
 mov [LineAddress],eax
 mov [LineAddressY],esi
%endmacro

%macro SORT_TILES_16_TALL 0
; parameters: edx
; uses: eax, esi, 0-label
; returns: ebx, LineAddress, LineAddressY

 Get_Current_Line

 add eax,[VScroll+edx]
 shl eax,2          ; Get screen offset
 mov ebx,0x1F0*4    ; Current line + V scroll * 32words
 and ebx,eax
 and eax,byte 0x0F*4    ; Offset into table of line offsets
 mov esi,16*8*8+8*7
 mov eax,[Tile_Offset_Table_64_8+eax]
 sub esi,eax
 mov [LineAddress],eax
 mov [LineAddressY],esi
%endmacro

;%1 = BGmask
%macro CALCULATE_MOSAIC_YLINE 1
 ; uses: eax, edx, ebp, 0-label
 ; returns: Current_Line_Mosaic
 mov al,[MOSAIC]
 test al,%1
 jz %%no_mosaic
 test al,0xF0
 jz %%no_mosaic
 mov eax,[Current_Line_Render]
 xor edx,edx
 mov ebp,[Mosaic_Size]
 dec eax
 div ebp
 mul ebp
 inc eax
 mov [Current_Line_Mosaic],eax
%%no_mosaic:
%endmacro

%macro LOAD_BG_TABLE 1
 mov edx,TableBG%1
%endmacro

%endif ; SNEeSe_screen_ni
