; SPC700 opcodes 0x40-0x4F:
;    40: SETP            1,2
;    41: TCALL 4         1,8
;    42: SET1 dp.2       2,4
;    43: BBS dp.2,rel    3,5/7
;    44: EOR A,dp        2,3
;    45: EOR A,labs      3,4
;    46: EOR A,(X)       1,3
;    47: EOR A,(dp+X)    2,6
;    48: EOR A,#imm      2,2
;    49: EOR dp(d),dp(s) 3,6
;    4A: AND1 C,mem.bit  3,4
;    4B: LSR dp          2,4
;    4C: LSR labs        3,5
;    4D: PUSH X          1,4
;    4E: TCLR1 labs      3,6
;    4F: PCALL upage     2,6
;

; 40
ALIGNC
SPC_SETP:
 inc R_NativePC
 SET_FLAG_SPC SPC_FLAG_P
 CLR_FLAG_SPC SPC_FLAG_I
 mov byte [SPC_PAGE+1],1
 jmp SPC_BACK

; 41
TCALL 4
; 42 - SPC_SET1 in SPCmain.S
; 43 - SPC_BBS in SPCmain.S
; 44
SPC_EOR_A dp
; 45
SPC_EOR_A abs
; 46
SPC_EOR_A OXO
; 47
SPC_EOR_A OOdp_XOO
; 48
ALIGNC
SPC_EOR_A_IM:
 SPC_OP_A_IM EOR,SPC_FLAG_NZ

; 49
SPC_EOR_mem dp_dp
; 4A
ALIGNC
SPC_AND1:       ; Carry flag = Carry flag AND mem.bit
 ADDR_membit    ; bx contains mem and dx contains bit number
 GET_BYTE_SPC   ; Get byte at location
 bt eax,edx
 LOAD_BASE
 jc near SPC_BACK        ; C & 1 = C
 CLR_FLAG_SPC SPC_FLAG_C    ; C & 0 = 0
 jmp SPC_BACK

; 4B
SPC_LSR dp
; 4C
SPC_LSR abs
; 4D
SPC_PUSH_reg X
; 4E
ALIGNC
SPC_TCLR1:          ; I have done this as TRB (65816) including the flag setting based on AND
 ADDR_abs
 mov cl,B_A
 GET_BYTE_SPC   ; Get byte
 test cl,al     ; NZ set for: mem & A
 STORE_FLAGS_SPC SPC_FLAG_NZ
 xor cl,0xFF
 and al,cl
 SET_BYTE_SPC   ; mem &= ~A
 jmp SPC_BACK

; 4F
ALIGNC
SPC_PCALL:  ; u-page is the last page on the SPC RAM (uppermost-page!)
 GET_PC eax
 add eax,byte 2
 PUSH_W
 mov eax,0xFF00
 mov al,[1+R_NativePC]  ; upage offset
 cmp al,0xC0
 mov R_NativePC,eax
 mov eax,[SPC_FFC0_Address]
 jnb .possible_rom
 mov eax,_SPCRAM
.possible_rom:
 add R_NativePC,eax
 mov B_SPC_Code_Base,eax
 jmp SPC_BACK
